*** changes.orig	Fri Dec 10 06:52:58 1999
--- changes	Sun Jan 16 14:34:52 2000
***************
*** 4579,4585 ****
  ignored later. 
  
  7/30/99 (bug fix) Added functions to stub table, patch provided by Jan
! Njitmans. [Bug: 2445] (hobbs)
  
  8/1/99  (bug fix) Changed Windows socket driver to terminate threads
  by sending a message to the window rather than calling
--- 4579,4585 ----
  ignored later. 
  
  7/30/99 (bug fix) Added functions to stub table, patch provided by Jan
! Nijtmans. [Bug: 2445] (hobbs)
  
  8/1/99  (bug fix) Changed Windows socket driver to terminate threads
  by sending a message to the window rather than calling
***************
*** 4710,4712 ****
--- 4710,5215 ----
  cases (different causes).
  
  --- Released 8.2.3, December 16, 1999 --- See ChangeLog for details ---
+ 
+ The following changes are for the '+'-version,
+ written by:	Jan Nijtmans
+ 		CMG (Computer Management Group) Arnhem B.V.
+ 		email: j.nijtmans@chello.nl (private)
+ 		       jan.nijtmans@cmg.nl (work)
+ 		url:  http://purl.oclc.org/net/nijtmans/
+ 
+ 6/26/95 (new feature) Added support for creating standalone support.
+ 	Now the library has a function Tcl_InitStandAlone() which is
+ 	a repacement for Tcl_Init(). The difference is that using this
+ 	new function makes any application independant from the tcl
+ 	library, because it will be compiled into the binary executable.
+ 
+ 6/26/95 (new feature) Changed configure and Makefile for creating
+ 	a shared library for Tcl7.4. Has been tested successfully
+ 	for Sun (SunOS-4 and Solaris), HP, SGI, AIX and OSF/1,
+ 	but is easlily extensible for other systems.
+ 
+ 7/3/95  Updated for the official release of Tcl7.4
+ 
+ 7/18/95 Some changes to tclAppInit.c, such that it can be
+ 	compiled with c++.
+ 	    make tclsh++		c++ version of tclsh
+ 
+ 8/28/95	Updated to autoconf-2.4
+ 
+ 9/20/95 Updated all for Tcl7.4p2.
+ 
+ 10/5/95 Improved above interface for multiple interpreters.
+ 
+ 10/6/95 Patched tclExpr.c, to solve a DOMAIN error when using
+ 	shared libraries on some systems (SunOS-4, HP-UX)
+ 
+ 11/21/95 Changed tests to used the loadable extension tcltest${SHLIB_SUFFIX}
+ 
+ 12/1/95 Updated everything for Tcl7.4p3
+ 
+ 12/6/95 Added some mathematical functions that are in many math
+ 	libraries (at least HP-UX, SunOS-4, Solaris, Irix and Ultrix):
+ 	erf(), erfc(), lgamma(), j0(), j1(), jn(), y0(), y1() and yn().
+ 
+ 12/12/95 Changed suffix for position independant objects to "..o", to
+ 	 assure that all linkers accept and recognize it.
+ 
+ 1/5/96	Supply both TclTest_Init() and Tcltest_Init() for
+ 	compatibility with tclX7.4a
+ 
+ 2/6/96  Update everything for Tcl7.5b1
+ 
+ 2/6/96  Rewrite Main-loop such that Tk is dynamically loadable.
+ 
+ 2/13/96 Adapt dynamical loading for c++ loadable libraries
+ 
+ 2/19/96 Adapted tclLoadDl.c such that the current path is checked first
+ 	when trying to load the dynamic library.
+ 
+ 2/19/96 Adapted tclLoadAout.c such that the directories in the environment
+ 	variable LD_LIBRARY_PATH and the patch /usr/lib and /lib are
+ 	searched too.
+ 
+ 2/20/96 Adapted tclTest.c such that it behaves as a separate package,
+ 	and can be compiled with any C++-compiler too.
+ 
+ 2/21/96 Corrected tclsh.standalone for multiple interpreters. Until
+ 	now it only was standalone as long as only a single interpreter
+ 	was used.
+ 
+ 2/26/96 Updated everything for Tcl7.5b2
+ 
+ 2/27/96 Added C++-support for OSF loadable modules.
+ 
+ 2/28/96 Changed PWD to BUILD_DIR, thereby removing problems if the
+ 	tcl build directory is a symbolic link
+ 
+ 3/7/96  Renamed tclsh to tclsh7.5 in build directory too. Supply a
+ 	link to the original name for compatibility.
+ 
+ 3/7/96  Adapt tests to load tcltest.so by the "package require" command
+ 
+ 3/8/96  Added pkgIndex.tcl for build and dltest directories. These are
+ 	constructed by the configure script (so without the need for
+ 	the actual libraries). But the Makefiles also contain rules
+ 	to construct these by the pkg_mkIndex command.
+ 
+ 3/11/96 Fixed rejects for new b3 release.
+ 
+ 3/13/96 Adapt tclPkgSetup to accept full-path filenames. Adapt
+ 	pkg_mkIndex not to put an error-message when a file cannot
+ 	be loaded or sourced. This is needed to create a pkgIndex.tcl
+ 	file for Tk.
+ 
+ 3/14/96 Adapted tclLoadShl.c to use emulation of dlopen, dlsym and dlerror.
+ 	this makes it possible to search for symbols in shared libraries
+ 	by other extensions.
+ 
+ 3/18/96 Added generation of TCL_ERROR in the Tcl_WaitForEvent() functions
+ 	of the mac and win ports.
+ 
+ 3/22/96 Initialize firstFileHandlerPtr to NULL
+ 
+ 4/8/96  Added small namespace facility (namesp.tcl), and added the "tcl"
+ 	command.
+ 
+ 4/10/96 Removed tclUnixMain.c, and instead create patch for tclMain.c
+ 	which does the same. Also changed the mechanism such that
+ 	it should work for Windows and Mac too (hopefully).
+ 
+ 4/22/96 Adapted everything for final Tcl7.5
+ 
+ 4/25/96 Removed some tests for versions numbers in the Makefile. These are no
+ 	longer necessary because the version number is now always either with
+ 	or without dots, but never missing.
+ 
+ 5/1/96	Adapted Makefile such that incremental linking in shared libraries
+ 	is only used for a.out loadable libraries. For other systems it
+ 	doesn't give any benefit, and for SunOS-4 it even goes wrong.
+ 
+ 5/10/96 Added "package require" commands to "hello.tcl"
+ 
+ 5/15/96 Added workaround for "-o" bug in UnixWare compiler
+ 
+ 5/20/96 Update to use autoconf 2.10
+ 
+ 5/22/96 Added dummy reference to "fabs" in tclMtherr.c. This should
+ 	make Tk dymanically loadable on systems that don't have a
+ 	shared math library.
+ 
+ 5/24/96 Added separate tests for the presence of shared math and c
+ 	libraries. Removed "AIX_TCL_LIB_SPEC", because that should
+ 	be handled correctly by @SHLIB_LD_LIBS@ now. Let's hope
+ 	this works for all systems.
+ 
+ 5/30/96 Better support for Mac and Windows ports.
+ 
+ 6/4/96  Changed ldAout.tcl and tclLoadAout.c such that a.out dynamical
+ 	libraries are more forgiving in respect to the extension. Suffixes
+ 	like ".so", or even ".so.x.y" or "..o.x.y" are now accepted too
+ 
+ 6/4/96  Adapted tclTest.c, tclUnixTest.c and pkga.c .. pkge.c such that
+ 	no warnings about unused arguments are given by some C++ compilers.
+ 
+ 8/6/96  Updated everything for Tcl7.5p1
+ 
+ 8/7/96  Corrected bug in pkg_mkindex proc for Ultrix. Also, extended
+ 	this procedure such that it can make index files for packages
+ 	that depend on other packeges; not only for Tk.
+ 
+ 8/8/96  Added function Tcl_FindPackageHandle(). Needed to make libitk2.1.so
+ 	dynamically loadable in some circumstances on SunOS4.
+ 
+ 8/9/96  Adapted pkgIndex.tcl files to work for directories containing
+ 	spaces too.
+ 
+ 8/12/96 Fixed a few event tests for working together with tclsh.static.
+ 
+ 8/22/96 Removed erf(), erfc() and lgamma() functions for Windows and Mac
+ 	ports.
+ 
+ 8/26/96 Changed activeFlag in tclMacNotify.c into tclActiveFlag (Oops....)
+ 
+ 8/27/96 Improved standalone handling such that now all scripts can be
+ 	re-loaded. So, now auto_reset works in tclsh.standalone too.
+ 
+ 8/28/96 Use mkinstalldir script for creating directory hierarchies.
+ 
+ 9/2/96  Adapted everyting for  Tcl7.6b1.
+ 
+ 9/2/96  Added support for tkcon (by Jeffrey Hobbs). If tkcon.tcl is
+ 	present in the Tcl script directory, it will be used as the
+ 	console for tclsh. If the initialization is not possible
+ 	(e.g. because Tk is not compiled yet) the old console is
+ 	used (which doesn't work yet on Mac and Windows)
+ 
+ 20/9/96 Added dlsym() emulation for all platforms.
+ 
+ 30/9/96 Added option "-with-x", which links X11 with tclsh7.6. This
+ 	might be usefull if you don't have a shared X11 library.
+ 
+ 1/10/96 Upgrade to tkcon version 0.64, expanded with a limited set
+ 	of safe-tk such that it runs in the Netscape plugin too.
+ 
+ 10/23/96 Adapted everyting for final Tcl7.6 release.
+ 
+ 10/28/96 Added TclGuessPackageName for Ultrix, to assure that the
+ 	 possible "_G0" part of the filename is not taken as
+ 	 belonging to the package name.
+ 
+ 10/29/96 Added flag DYNAMIC_PATH to shl_load() function for HP-UX.
+ 	 That makes it more likely that loading dynamical libraries
+ 	 will succeed.
+ 
+ 10/30/96 Small bug fix in win/tclWinSock.c (reported by Jim Barton
+ 	 in comp.lang.tcl)
+ 
+ 10/31/96 Fixed two small bugs, reported by Frederic Bonnet. One has
+ 	 to do with an invalid  TEST_SUFFIX="${.a}", which of
+ 	 course should be   TEST_SUFFIX=".a" in the configure scripts.
+ 	 The other one is an ill-treatment of tclLoadNone.c when
+ 	 the system is not on the list of supported systems.
+ 
+ 11/1/96  Just a few cleanups to eliminate gcc warnings when -Wall
+ 	 is used.
+ 
+ 11/4/96  Fixed small bug in "update idletask"
+ 
+ 11/6/96  Small bug-fix in tclLoadAix.c
+ 
+ 11/13/96 Upgrade to TkCon 0.67
+ 
+ 11/14/96 Upgrade to TkCon 0.68
+ 
+ 11/15/96 Removed event fixes from Mac and Windows ports. They seem
+ 	 to ruin the console. Pity but true.
+ 
+ 11/20/96 A few adaptations for the Mac (Thanks to Vince Darley)
+ 
+ 11/22/96 Upgrade to TkCon 0.70
+ 
+ 11/26/96 Add some more undefined symbols to tclsh when the shared
+ 	 c-library is missing for some system. Without this,
+ 	 libtclx7.6.0.so is not dynamically loadable.
+ 
+ 11/29/96 Upgrade to autoconf-2.12
+ 
+ 12/2/96  Implemented dlclose() for Windows
+ 
+ 12/2/96  Added gcc's __builtin functions.
+ 
+ 12/3/96  Added reference to signgam in tclExpr.c. Needed when
+ 	 using the shared math lib in combination with the
+ 	 shared AIX tcl7.6 library.
+ 
+ 12/5/96  Removed Itcl namespaces: Itcl2.2 is about to be released
+ 	 now, so better keep this separate.
+ 
+ 12/5/96  New C functions Tcl_ReplaceChannel() and
+ 	 Tcl_UndoReplacechannel() needed for the Trf package. Also
+ 	 a new tcl-command "unstack" to undo the replacement of a
+ 	 channel in Tcl-code. These functions are written by
+ 	 Andreas Kupries.
+ 
+ 12/10/96 Renamed internal index data from "tclIndex" to "tcl:tclIndex",
+ 	 for more consistance with Itcl2.2.
+ 
+ 12/10/96 Added the "info resource" command.
+ 
+ 12/11/96 Bug-fix in Tcl_Main, which prevented additional packages to
+ 	 be initialized in combination with the tkCon console.
+ 
+ 12/11/96 Small bug-fix for Ultrix: Guess of package name went wrong
+ 	 if the file name ended with _G0.a and if the package name
+ 	 was only a single character.
+ 
+ 12/13/96 Ultrix doesn't accept the "-h" option for test. This error
+ 	 is ignored now.
+ 
+ 12/20/96 Added possibility to turn off TkCon by setting the
+ 	 variable NoTkCon in .tclshrc.
+ 
+ 1/8/97   Adapted everyting for Tcl 8.0a1
+ 
+ 1/13/97  Upgrade to TkCon 0.71
+ 
+ 1/13/97  Made restricted "open" function available to safe interpreters.
+ 
+ 1/17/97  No longer create links from the /unix/libtk8* to the
+ 	 /<build-dir>/libtk8* files. Just too dangerous in case
+ 	 these directories are the same and the system doesn't
+ 	 recognize "test -h".
+ 
+ 1/23/97  Changed syntax for $tcl_prompt1 and $tcl_prompt2 variables
+ 	 to return a prompt string in stead of writing it to stdout
+ 	 directory. The old syntax is still supported as well.
+ 	 After a suggestion from Dan Ellis <dpwe@icsi.berkeley.edu>.
+ 
+ 1/27/97  Adapted everything for Tcl 8.0a2
+ 
+ 1/28/97  Added functions for controlling byte ordering for channels.
+ 	 Contributed by Andreas Kupries <a.kupries@westend.COM>.
+ 
+ 1/29/97  Moved tcl.h installation from "make install-libraries"
+ 	 to "make install-binaries". Just more logical.
+ 
+ 2/3/97   Added check in tclUnixMain.c whether stdin channel changes
+ 	 during command evaluation. Suggested by Dean Hinshaw.
+ 
+ 2/11/97  A few fixes in test suite. Now it runs with Tkcon as well.
+ 
+ 2/20/97  Modified ldAout.tcl such that it is more forgiving to
+ 	 functions starting with '_'. The C++ adaptation is no
+ 	 longer done by ldAout.tcl (at compile-time), but by
+ 	 tclLoad.c (at run-time).
+ 	 
+ 3/10/97	 Modified tclLoadAout.c to use the environment variable
+ 	 LD_LIBRARY_PATH in the same way as other systems do it.
+ 
+ 3/14/97  Changed Tcl_Init() such that it always returns TCL_ERROR
+ 	 or TCL_OK. Previously used to return TCL_BREAK;
+ 
+ 5/22/97  Added standalone support for Windows (VC++ only). Thanks
+ 	 to John Wehle <john@feith.com> and Andreas Kupries for
+ 	 fixing this. Hopefully everything works now.
+ 
+ 7/2/97   Adapt everything for Tcl8.0b1
+ 
+ 7/3/97   Upgrade to tkcon version 1.0.2
+ 
+ 7/5/97   Adapt everything for Tcl8.0b2
+ 
+ 7/12/97  Upgrade to tkcon version 1.0.3. Adapted it to use the new
+ 	 Menu functions, so it looks better on Windows and Mac.
+ 
+ 8/11/97  Adapt everything for Tcl 8.0.
+ 
+ 8/25/97  Added bug-fixes from Jeffrey Hobb's archive.
+ 
+ 8/26/97  Many bug-fixes in makefile.vc.
+ 
+ 8/28/97  Completed Standalone support for Windows port. Now it has
+ 	 the same functionality as the original UNIX implementation.
+ 
+ 8/31/97  Added support for opt0.1 package in standalone executables.
+ 
+ 9/4/97   A few bug fixes, as reported by John Lilleyman
+ 	 <jml@cbr.dit.csiro.au>
+ 
+ 9/7/97   Modified makefile.bc for standalone executables.
+ 
+ 9/17/97  More fixes for makefile.bc allowing standalone support. With
+ 	 assistance from Scott Plitsche <SPlischke@aol.com> and
+ 	 Steve Blinkhorn <steve@prd.co.uk>.
+ 
+ 10/3/97  Renamed Tclotest.so to Objtest.so and Tclptest.so to Unixtest.so.
+ 	 pkgIndex.tcl is now produced by makefile in stead of configure.
+ 
+ 11/11/97 Adapted everything for Tcl8.0p1
+ 
+ 11/12/97 Upgrade to TkCon 1.1
+ 
+ 11/18/97 Added TCLX_REQUIRED_PATCHES and TCLPLUGIN_REQUIRED_PATCHES.
+ 
+ 11/19/97 A few small bug-fixes for Windows.
+ 
+ 11/20/97 Bug fix for Solaris 2.4 strtod() defined twice.
+ 
+ 11/26/97 Upgraded everything for Tcl8.0p2
+ 
+ 11/26/97 Removed TCLX_REQUIRED_PATCHES and TCLPLUGIN_REQUIRED_PATCHES.
+ 	 Will no longer be necessary for TclX8.0.2 and Tclplugin 2.0.5beta
+ 	 (hopefully).
+ 
+ 11/29/97 Disabled dynamical loading in tcl80sa.lib: It doesn't work
+ 	 anyway because extensions always depend on tcl80.dll which
+ 	 is no longer available. Even when tcl80.dll is available,
+ 	 all global variables will have two copies: One in the
+ 	 standalone executable and one in tcl80.dll. This easily
+ 	 results in a crash. :-(
+ 
+ 12/7/97  Fixed compile errors in tclTest.c and tclObjTest.c, for
+ 	 non-ANSI compilers. Thanks to Anke Selig
+          <Anke.Selig@oi42.kwu.siemens.de> for reporting this bug.
+ 
+ 12/9/97  Fixed socket test 7.3
+ 
+ 12/14/97 Undid changes in tclWinSock.c: those changes where merely
+          meant to test the new interface in tclLoadWin.c, but it
+          broke socket handling in standalone executables.
+          Problem reported by M'hamed Boubkari <bo@xs4all.nl>
+ 
+ 12/20/97 Solved problem for AIX, which resulted in unknown "-u"
+          options for the linker.
+ 
+ 12/27/97 Added some suggestions from Viktor Dukhovni <viktor@nyc.deshaw.com>
+          (posted 12/24/97 on comp.lang.tcl)
+ 
+ 1/2/98   Changed reference to opt 0.1 package to opt 0.2. This made
+ 	 some tests to fail. Reported by Daniel Cotey <danielc@minc.COM>
+ 
+ 1/11/98  A few fixes for Windows and Mac, regarding compilation with
+ 	 BC 4.52/5.02 supplied by  Adam Karpierz <karpierz@inter.intertele.pl>
+ 	 Thanks very much.
+ 
+ 3/4/98   (bug fix) Included Martin Andrews' fixes, making everything
+ 	 compile with Borland 5.0.
+ 
+ 5/18/98  Changed "worldaccess.nl" into "wxs.nl", due to the migration
+          of worldaccess to a new domain.
+ 
+ 6/16/98  Removed event-changes; it didn't work completely with
+          Tcl/Tk 8.0 anyway, so it's better not to leave traces,
+ 	 in order to assure maximum compatibility with the official
+ 	 Tcl/Tk distribution.
+ 
+ 6/20/98  Added "const" back into many function prototypes.
+ 
+ 7/19/98  (bug-fix) Too early call of the FreeLibrary() function in
+          tclLoadWin.c, resulted in crash when an application using
+          dynamic extensions in Windows exits.
+ 
+ 8/6/98   Upgrade everything for Tcl8.0.3 final (Brent Welch)
+ 
+ 8/24/98  Created new patch-files from Brent's plus-distribution,
+          so his additional fixes/enhancements are official now.
+ 
+ 9/5/98   Changed name of standalone library and executable for
+          windows to "tcl80s.lib" resp. "tclsh80s.exe", for
+          compatibility with tclPro.
+ 
+ 9/12/98  Added changes suggested by Mumit Khan
+          <khan@xraylith.wisc.edu> for mingw32.
+          Makefile.gnu not added yet.
+ 
+ 11/22/98 Upgrade everything for Tcl8.0.4 final.
+ 
+ 12/4/98  Added Makefile.gnu providing support for
+ 	 Mingw32/cygwin32 compiler. (only tested
+ 	 with september 9 version of mingw32)
+ 
+ 12/28/98 Massive modification to Makefile.gnu for
+ 	 CYGWIN-B20.1, using the new "-mno-cygwin"
+ 	 option. This allows the creation of dll's
+ 	 and executables which are independant from
+ 	 "cygwinb1.dll"; Very important for standalone
+ 	 executables.
+ 
+ 3/20/99  Adapted everything for 8.1b2
+ 
+ 5/8/99   Adaped everything for 8.1
+ 
+ 5/10/99  Added TK_PATCHES. From now on, the Tk plus-patch
+ 	 will be included in the Tcl plus-patch, such
+ 	 that they can be distributed together as one file.
+ 
+ 5/11/99  Added TCLX_PATCHES, a first shot at Stub-implementation
+ 	 for TclX 8.1.0. Not yet complete.
+ 
+ 5/30/99  Added Hirano Motonori's internationalization patches.
+ 
+ 5/30/99  Renamed tclUnixMain.c to tclStdMain.c, and adapted it
+          such that it is usable for Windows as well.
+ 
+ 6/20/99  Fixed Tk for running the Tk thread tests.
+ 
+ 7/3/99   Added new BLT_PATCHES and TCLX_PATCHES, meant for Blt 2.4i
+ 	 and TCLX 8.1.1
+ 
+ 7/25/99  Updated everything to Tcl8.2b1
+ 
+ 7/25/99  Upgrade to autoconf 2.13.
+ 
+ 7/31/99  Added functions from tkText.h to the stub table. This makes
+ 	 tkText.o compilable as a loadable library (at last).
+ 
+ 9/2/99   Updated everything to Tcl8.2.0
+ 
+ 9/2/99   Added two fixes from Matt Newman
+ 
+ 9/24/99  Changed "PASCAL FAR" to WINAPI in tclWinSock.c
+ 
+ 10/5/99  Removed exclamation marks from tclLoadNone.c
+          Left over from file diff.
+ 
+ 10/6/99  Adapted everything for 8.2.1
+ 
+ 10/7/99  Modified BLT_PATCHES for 2.4j
+ 
+ 10/9/99  Modified TclpGetStartupEncoding() to use Tcl_Obj's in stead
+ 	 of strings.
+ 
+ 10/9/99  Added the variables $tclplatform(encoding) and
+ 	 $tclplatform(locale) (unix-only)
+ 
+ 11/6/99  Fixed the XIM handling (international fonts on UNIX).
+ 	 Bug report and fix by David Engel <dlengel@home.com>
+ 
+ 11/6/99  Made plus-patched Tk compilable with standard Tcl,
+ 	 by making all additional function references
+ 	 stub-indirect.
+ 
+ 11/8/99  Fixed Expect problem: Because Expect calls Tk_ParseArgv()
+ 	 or TkCreateFrame() first, Tcl's stub table doesn't get the
+ 	 chance to be initialized. Solution: call Tcl_InitStubs()
+ 	 in those functions. Problem reported by David Engel
+ 	 <dlengel@home.com>.
+ 
+ 11/14/99 Further solution for Expect-problem: Initialize Tk's
+ 	 stub table as well in TkCreateFrame().
+ 
+ 1/15/2000 Added patch submitted by David Graveraux, regarding
+ 	  TclpAsyncMark function in multi-threaded Tcl.
+ 
+ 1/15/2000 Added ebcdic.enc
+ 
+ 1/15/2000 Updated everything for Tcl8.2.3
+ 
+ 1/16/2000 Added the "latin" encoding, and made "iso8859-1" an
+           internal encoding. This makes the iso8859-1 encoding
+           available to standalone executables.
+ 
+ 1/16/2000 Backported fix for bugID 3377 from Tk8.3b2
+ 
+ ----------------- Released 8.2.3+, 1/16/2000 -----------------------
